%define	lib_major 1
%define	lib_name %mklibname %{name}%{lib_major}
%define	devel_name %mklibname %{name} -d
%define libminizip %mklibname minizip %{lib_major}
%define minizip_devel %mklibname minizip -d

%define build_biarch 0
# Enable bi-arch build on ppc64, sparc64 and x86-64
%ifarch sparcv9 sparc64 x86_64 ppc64
%define build_biarch 1
%endif
%ifarch sparcv9
%define	_lib	lib64
%endif
%define build_minizip 1

%bcond_without dietlibc

Summary:	The zlib compression and decompression library
Name:		zlib
Version:	1.2.8
%define subrel	1
Release:	%mkrel 7
Group:		System/Libraries
License:	BSD
URL:		http://www.gzip.org/zlib/
Source0:	http://prdownloads.sourceforge.net/libpng/%{name}-%{version}.tar.gz
Patch0001:	0001-Remove-dummy-structure-declarations-for-old-buggy-co.patch
Patch0002:	0002-Remove-offset-pointer-optimization-in-inftrees.c.patch
Patch0003:	0003-Use-post-increment-only-in-inffast.c.patch
Patch0004:	0004-Avoid-shifts-of-negative-values-inflateMark.patch
Patch0005:	0005-Avoid-pre-decrement-of-pointer-in-big-endian-CRC-cal.patch

BuildRequires:	util-linux
%if %{with dietlibc}
BuildRequires:	dietlibc-devel
%endif
%if %{build_minizip}
BuildRequires:	zlib-devel
%endif

%description
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{lib_name}
Summary:	The zlib compression and decompression library
Group:		System/Libraries
Requires(pre):	filesystem >= 2.1.9-18
Obsoletes:	libz, libz1, %{name}
Obsoletes:	%{name}%{lib_major} < 1.2.5
Provides:	libz = %{version}-%{release}
Provides:	libz1 = %{version}-%{release}
Provides:	%{name} = %{version}-%{release}

%description -n	%{lib_name}
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{devel_name}
Summary:	Header files and libraries for developing apps which will use zlib
Group:		Development/C
Requires:	%{lib_name} = %{version}-%{release}
Obsoletes:	libz1-devel libz-devel zlib-devel zlib1-devel
Obsoletes:	%{name}%{lib_major}-devel < 1.2.5
Provides:	libz-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n	%{devel_name}
The zlib-devel package contains the header files and libraries needed
to develop programs that use the zlib compression and decompression
library.

Install the zlib-devel package if you want to develop applications that
will use the zlib library.

%if %{build_minizip}
%package -n     %{libminizip}
Summary:        Minizip manipulates files from a .zip archive
Group:          System/Libraries

%description -n %{libminizip}
Minizip manipulates files from a .zip archive.

%package -n     %{minizip_devel}
Summary:        Development files for the minizip library
Group:          Development/C
Requires:       %{libminizip} = %{version}-%{release}
Requires:       zlib-devel = %{version}-%{release}
Provides:       libminizip-devel = %{version}-%{release}
Provides:       minizip-devel = %{version}-%{release}

%description -n %{minizip_devel}
This package contains the libraries and header files needed for
developing applications which use minizip.
%endif

%prep
%setup -q
%autopatch -p1

%build
#(peroyvind): be sure to remove -m64/-m32 flags as they're not overridable
RPM_OPT_FLAGS="`echo $RPM_OPT_FLAGS| sed -e 's/-m.. //g'` -O3"
mkdir objs
cp -a $(ls | grep -v objs) objs/
pushd objs
  CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="%{?ldflags}" \
%if %{build_biarch}
  CC="%{__cc} -m64" \
%endif
  ./configure --shared --prefix=%{_prefix} --libdir=%{_libdir}
  %make
  make test
popd

%if %{build_minizip}
pushd contrib/minizip
autoreconf --install
%configure2_5x --enable-static=no
%make
popd
%endif

%if %{build_biarch}
%ifarch %{sunsparc}
RPM_OPT_FLAGS_32="$RPM_OPT_FLAGS"
%else
RPM_OPT_FLAGS_32=`linux32 rpm --eval %%{optflags}`
%endif
mkdir objs32
cp -a $(ls | grep -v objs) objs32/
pushd objs32
  CFLAGS="$RPM_OPT_FLAGS_32" LDFLAGS="%{?ldflags}" CC="%{__cc} -m32" \
  ./configure --shared --prefix=%{_prefix}
  %make
  make test
popd
%endif

%if %{with dietlibc}
mkdir objsdietlibc
cp -a $(ls | grep -v objs) objsdietlibc/
pushd objsdietlibc
  CFLAGS="-Os" CC="diet gcc" \
  ./configure --prefix=%{_prefix}
  %make libz.a
popd
%endif


%install
install -d %{buildroot}/%{_prefix}
install -d %{buildroot}/%{_libdir}

make install -C objs prefix=%{buildroot}%{_prefix} libdir=%{buildroot}%{_libdir}
%if %{build_biarch}
make install-libs -C objs32 prefix=%{buildroot}%{_prefix}
%endif

%if %{build_minizip}
pushd contrib/minizip
%makeinstall_std
popd
%endif

%if %{with dietlibc}
install -m644 objsdietlibc/libz.a -D %{buildroot}%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif

%if %{build_minizip}
rm -fr %{buildroot}%{_libdir}/libminizip.la
%endif

%files -n %{lib_name}
%doc README
%{_libdir}/libz.so.%{lib_major}*
%if %{build_biarch}
%{_prefix}/lib/libz.so.%{lib_major}*
%endif

%files -n %{devel_name}
%doc README ChangeLog doc/algorithm.txt
%{_mandir}/man3/zlib.3*
%{_libdir}/*.a
%{_libdir}/*.so
%if %{build_minizip}
%exclude %{_libdir}/libminizip.so
%endif
%{_libdir}/pkgconfig/zlib.pc
%if %{build_biarch}
%{_prefix}/lib/*.a
%{_prefix}/lib/*.so
%{_prefix}/lib/pkgconfig/zlib.pc
%endif
%{_includedir}/zconf.h
%{_includedir}/zlib.h
%if %{with dietlibc}
%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif

%if %{build_minizip}
%files -n %{libminizip}
%{_libdir}/libminizip.so.%{lib_major}*

%files -n %{minizip_devel}
%{_libdir}/pkgconfig/minizip.pc
%{_libdir}/libminizip.so
%{_includedir}/minizip
%endif


%changelog
* Tue Oct 04 2016 luigiwalser <luigiwalser> 1.2.8-7.1.mga5
+ Revision: 1058613
- add upstream patches to fix issues found by mozilla security audit

* Wed Oct 15 2014 umeabot <umeabot> 1.2.8-7.mga5
+ Revision: 747129
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 1.2.8-6.mga5
+ Revision: 730757
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 1.2.8-5.mga5
+ Revision: 690882
- Mageia 5 Mass Rebuild

* Wed Aug 20 2014 tv <tv> 1.2.8-4.mga5
+ Revision: 665832
- drop uclibc build

* Mon Dec 16 2013 boklm <boklm> 1.2.8-3.mga4
+ Revision: 557186
- Rebuild for new uclibc

* Sat Oct 19 2013 umeabot <umeabot> 1.2.8-2.mga4
+ Revision: 532944
- Mageia 4 Mass Rebuild

* Mon Jul 08 2013 luigiwalser <luigiwalser> 1.2.8-1.mga4
+ Revision: 451058
- 1.2.8

* Mon Jan 14 2013 umeabot <umeabot> 1.2.7-7.mga3
+ Revision: 387754
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Sep 17 2012 fwang <fwang> 1.2.7-6.mga3
+ Revision: 294833
- bump rel

* Mon Sep 17 2012 fwang <fwang> 1.2.7-5.mga3
+ Revision: 294829
- setarch merged into util-linux

* Sat Jul 21 2012 colin <colin> 1.2.7-4.mga3
+ Revision: 273158
- Update for usrmove

* Sat Jul 07 2012 dmorgan <dmorgan> 1.2.7-3.mga3
+ Revision: 268555
- Build minizip

* Tue May 29 2012 shlomif <shlomif> 1.2.7-1.mga3
+ Revision: 248898
- New version: 1.2.7

* Mon Jan 30 2012 fwang <fwang> 1.2.6-1.mga2
+ Revision: 203353
- new version 1.2.6

* Fri Oct 28 2011 tmb <tmb> 1.2.5-5.mga2
+ Revision: 159068
- split out uClibc-zlib(-devel) in separate rpms so basesystem-minimal
  does not require uClibc anymore.
- drop buildroot and defattr

* Sat Jan 08 2011 blino <blino> 1.2.5-3.mga1
+ Revision: 448
- imported package zlib

